#ifndef DATA_DEF_TYPE_INCLUDED
#define DATA_DEF_TYPE_INCLUDED



using namespace std;


typedef struct Elistic
{
     double sqr_dvi;       //    embedding depth between circle i and sides on x axis  =max(0,ri+xi-w)
     double sqr_dhi;       //    embedding depth between circle i and sides on y axis  =max(0,ri+yi-w)
     double sqr_dpi;       //    embedding depth between circle i and sides on z axis  =max(0,ri+zi-w)
     double sqr_dij;       // embedding depth betwenn circle i and  auther circle =max(0.ri+rj-sqrt(sqr(xi-xj)+sqr(yi-yj)))
     double ui;          // squeezing potiential of circle i;=sum d^2_ti (where t contains the sides and the other circles);
     double Feij_x;      // elstic force excerted by disk j on disk i ==dij.rij/|rij|; see article  A coarse-to-fine quais phyisical
                             // optimization methode for solving the circle packing problem with equilibrement constraints
     double Feij_y;      // elstic force excerted by disk j on disk i ==dij.rij/|rij|; see article  A coarse-to-fine quais phyisical
                         // optimization methode for solving the circle packing problem with equilibrement constraints
     double Feij_z;
     double DPi;   // degree of pain of the i circle;=ui;
     double RDPi;   // relative pain of circle i; ui/r^2_i;

} Elistic;


//un cercle
typedef struct Circle
{
    int    code;        // index of circles
    double x,y,z;      //coordonnées du cercle
    double r;          //rayon du cercle
    double Vx,Vy,VZ;   // velocity circle
    Elistic forceelistic;
} Circle;


typedef vector<Circle> listc;
typedef listc::iterator iterc;

typedef struct Particule
{
     int code;
     listc  conf;          //liste des cercles placés
     double LMax;          //function_obj
     double densite;

     double penality;      //if there is overlap
     double V_Lmax;
     listc  conf_Pbest;          //liste des cercles placés... best conf
     double LMax_Pbest;          //best functionObj
  double T;
} Particule;

typedef vector<Particule> Population;
typedef Population::iterator iterP;



//**************************************************************************************************
// variable globales
//**************************************************************************************************
int    n;               //nombre de cercles dans l'instance
double l_inf, l_sup;    //bornes inf et sup de l
double SURFACEINSTANCE;
 double w, h,l;            //largeur l et hauteur h , profondeur w du rectangle
 double TMAX;            //limite pour le temps de calcul, 0 si pas de limite

char NOM_Instance[30];	//nom du fichier contenant l'instance
char NOM_OPENGL[30];


const double EPSILON = 10E-6;


Particule G_best;
int POPULATIOSIZE;


//******************************************************************************************
                           // initialization
//******************************************************************************************

void InitializationForceElistic(Circle &c)
{
 c.forceelistic.DPi=0.0;
  c.forceelistic.RDPi=0.0;
  c.forceelistic.ui=0.0;
 c.forceelistic.Feij_x=0.0;
 c.forceelistic.Feij_y=0.0;
 c.forceelistic.Feij_z=0.0;
 c.forceelistic.sqr_dhi=0.0;
 c.forceelistic.sqr_dij=0.0;
 c.forceelistic.sqr_dpi=0.0;
 c.forceelistic.sqr_dvi=0.0;
}


void InitializationCircle(Circle &c)
 {
 c.code=0;
 c.r=0.0;
 c.x=0.0;
 c.y=0.0;
 c.z=0.0;
 c.Vx=0.0;
 c.Vy=0.0;
 c.VZ=0.0;
 InitializationForceElistic(c);
 }

void InitializationSolution(Particule &sol)
 {
  sol.code=0;
  sol.conf.clear();
  sol.conf_Pbest.clear();
  sol.LMax=0.0;
  sol.LMax_Pbest=0.0;
  sol.V_Lmax=0.0;
  sol.densite=0.0;
  sol.penality=0.0;
  sol.T=0.0;
 }

#endif // DATA_DEF_TYPE_INCLUDED
