#ifndef DRAW_INCLUDED
#define DRAW_INCLUDED


#include<GL/gl.h>
#include<GL/glx.h>
#include<GL/glu.h>
#include <exception>
#include <GL/glut.h>
#include <GL/freeglut.h>


#define PI     M_PI
#define TWOPI  2.0*M_PI


using namespace std;

//***************************************************************************************************************************
                                                //DESSIN 3D avec openGL
//***************************************************************************************************************************

const int    	LARGEUR = 1000;
const int    	HAUTEUR = 1000;
int		 GLUTWINDOW;

GLfloat xRotated=+23.0, yRotated=-40.0, zRotated; //on obtient une bonne visibilite, XRotated=+14.0, yRotated=-53.0 jusqu'au 22 juin 2013
GLfloat xTranslate=0.0, yTranslate=0.0;
float zoom		= 2.0; //agrandissment des objets , c'etait 8.0 jusqu'au 22 juin 2013
float adjustment	= 1.0; //rotation par rapport aux axes et pour les deplacement aussi


listc solution_a_dessiner_c;

char *ddd[1000];

//**********************************************************************************************************
//            BLOCK OPENGL DRAW 3D
//**********************************************************************************************************

void init(void)
{
 glEnable (GL_DEPTH_TEST);
 glEnable (GL_LIGHTING);
 glEnable (GL_LIGHT0);
}

void drawSphere(Circle c,int nb)
{
   int    	i, j;
   double 	phi1,phi2,theta, s, t;
   Circle    	e, p;
   double 	r = c.r;

   /*
   if (r < 0) r = -r;

   if (nb < 0) nb = -nb;

   if (nb < 4 || r <= 0) {
      glBegin(GL_POINTS);
      glVertex3f(c.x,c.y,c.z);
      glEnd();
      return;
   }
*/
   for (j=0; j<nb; j++) {
      phi1 = 1.0*j * TWOPI / nb;
      phi2 = 1.0*(j + 1.0) * TWOPI / nb;	//next phi

      glBegin(GL_QUAD_STRIP);
 glColor4f(0,1, 48.0/255.0, 1.0);
      for (i=0; i<=nb; i++) {
         theta = i * PI / nb;

        e.x = sin ( theta ) * cos ( phi2 );
	    e.y = sin ( theta ) * sin ( phi2 );
        e.z = cos ( theta );

        p.x = c.x + r * e.x;
        p.y = c.y + r * e.y;
        p.z = c.z + r * e.z;

        glNormal3f(e.x,e.y,e.z);
        s = phi2 / TWOPI;          // column
        t = 1 - theta/PI;          // row
	glTexCoord2f(s, t);

        glVertex3f(p.x,p.y,p.z);
glColor4f(48.0/255.0, 1, 0.0, 1.0);
        e.x = sin ( theta ) * cos ( phi1 );
	e.y = sin ( theta ) * sin ( phi1 );
        e.z = cos ( theta );
        p.x = c.x + r * e.x;
        p.y = c.y + r * e.y;
        p.z = c.z + r * e.z;

        glNormal3f(e.x,e.y,e.z);
        s = phi1/TWOPI;        // column
        t = 1 - theta/PI;      // row
        glTexCoord2f(s, t);

	glVertex3f(p.x,p.y,p.z);
	glColor4f(1, 48.0/255.0, 1, 1.0);

      }

      glEnd();
   }

}

void DrawCube()
{

double length=l, height=h, width=w;
 double max=0.0;

 if (length>max) max=length;
 if (width>max) max=width;
 if (height>max) max=height;

 length/=max; width/=max; height/=max;


//un cube a 8 points (x,y,z)


    /*glMatrixMode(GL_MODELVIEW);

    // clear the drawing buffer.
    glClear(GL_COLOR_BUFFER_BIT);

    glLoadIdentity();
     */

    //translatation par rapport a l'axe Z
    glTranslatef(0.0,0.0,-10.5);

    glRotatef(xRotated,1.0,0.0,0.0);

    // rotation about Y axis
    glRotatef(yRotated,0.0,1.0,0.0);

    // rotation about Z axis
    glRotatef(zRotated,0.0,0.0,1.0);


    glBegin(GL_LINE_LOOP); //GL_QUADS);        // Draw The Cube Using quads
    glColor3f(0.0f,0.0f,1.0f);    // Color RGB = Bleu

    //face de derriere
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 0.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 0.0f*zoom*width);

    glColor3f(0.0f,0.0f,0.0f);
    //face dessous et droite
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 0.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);

    //face de devant
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);



    //face haute et gauche
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 1.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    //glColor3f(0.0f,0.0f,0.0f);
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);
    glColor3f(0.0f,0.0f,1.0f);

    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 0.0f*zoom*width);
    glColor3f(0.0f,0.0f,0.0f);
    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 0.0f*zoom*width);

    glVertex3f( 0.0f*zoom*length, 1.0f*zoom*height, 1.0f*zoom*width);
    glVertex3f( 0.0f*zoom*length, 0.0f*zoom*height, 1.0f*zoom*width);


  glEnd();            // End Drawing The Cube

  for (iterc is=solution_a_dessiner_c.begin(); is!=solution_a_dessiner_c.end(); is++)
   {

     Circle s;

     s.x=is->x*zoom/max;
     s.y=is->y*zoom/max;
     s.z=is->z*zoom/max;
     s.r=is->r*zoom/max;
   //  density+=is->r*is->r*is->r;
      	//glEnable(GL_COLOR_MATERIAL);
//glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
//glPushAttrib( GL_CURRENT_BIT );

//glColor4f (1, 0, 0, 0.5);
//glDisable(GL_COLOR_MATERIAL);
//glPushMatrix();
     drawSphere(s, 100);
//glPopAttrib();
   }
    double density=calcule_la_densite(solution_a_dessiner_c,l);
    //double x, y;
    char s[95];
    sprintf(s,"l=%14.14lf  h=%10.14lf  w=%10.14lf  d=%7.4lf %c",l, h, w, density, '%');

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0, w, 0, w, -1.0f, 1.0f);
    glMatrixMode(GL_MODELVIEW);
    //glEnable(GL_COLOR_MATERIAL);//*******************************************************************************
    glPushMatrix();
    glLoadIdentity();
    glPushAttrib(GL_DEPTH_TEST);
    glDisable(GL_DEPTH_TEST);
    glRasterPos2i(0,0);//x,y);
    for (int i=0; i<strlen(s); i++)
    {
        glutBitmapCharacter(GLUT_BITMAP_9_BY_15, s[i]);
    }
    glPopAttrib();
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();

  /*for (iters is=solution_a_dessiner_c.begin(); is!=solution_a_dessiner_c.end(); is++)
   {

     Sphere s;

     s.x=is->x*zoom/max;
     s.y=is->y*zoom/max;
     s.z=is->z*zoom/max;
     s.r=is->r*zoom/max;

     drawSphere(s, 100);
   }*/

 glFlush();
}

// Handle keyboard input
void keyboard(unsigned char k, int x, int y) {
    switch (k) {
      case '+': zoom += adjustment/2; break; //le /2 a ete rajoute le 22 juin 2013 pour les 4 touches
      case '-': zoom -= adjustment/2; break;
      case '<': xTranslate-=adjustment/2; break;
      case '>': xTranslate+=adjustment/2; break;
     case 27 : glutDestroyWindow(GLUTWINDOW); break;//touche Escape
      exit(0);
         break;
      default:
         break;
      //default: return;
    }
   // glutPostRedisplay();
}

// Handle "special" keyboard input
void special(int k, int x, int y) { // le /2 22 juin 2013
    switch (k) {
      case GLUT_KEY_UP:    xRotated += adjustment; break;
      case GLUT_KEY_DOWN:  xRotated -= adjustment; break;
      case GLUT_KEY_LEFT:  yRotated += adjustment; break;
      case GLUT_KEY_RIGHT: yRotated -= adjustment; break;
      case GLUT_KEY_PAGE_UP:  yTranslate-=adjustment/2; break;
      case GLUT_KEY_PAGE_DOWN:  yTranslate+=adjustment/2; break;
      default: return;
    }
   // glutPostRedisplay();
}


void display()
{
    glClearColor (1.0,1.0,1.0,1.0);
     //glColor3f(0.5f, 0.0f, 1.0f);
     glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
     glLoadIdentity();
     gluLookAt (0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
     glTranslatef(xTranslate,yTranslate,0.0);
     DrawCube();
     glutSwapBuffers();
}

void reshape(int w_, int h_) //int x, int y)
{
    glViewport (0, 0, (GLsizei)w_, (GLsizei)h_);
     glMatrixMode (GL_PROJECTION);
     glLoadIdentity ();
     //c'etait gluPerspective (60, (GLfloat)w_ / (GLfloat)h_, 1.0, 100.0); //jusqu'au 22 juin 2013
     gluPerspective (20, (GLfloat)w_ / (GLfloat)h_, 1.0, 70.0);

     glMatrixMode (GL_MODELVIEW);
}

/*void drawSolution()
{

 glutDisplayFunc(display);
 glutIdleFunc(display);
 glutReshapeFunc(reshape);

 //glutKeyboardFunc(keyboard);
 //glutSpecialFunc(special);

 //printf("initialisation\n");
 //glutMainLoop();
 glutPostRedisplay();
}*/

int draw(listc conf, double Solution)
{
  // toujour le repere bottomleft
     ChangeLerepereVersBottomLeft(conf,Solution);

      solution_a_dessiner_c.clear();

      solution_a_dessiner_c= conf;
        l=Solution;


 glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
 glutInitWindowSize(LARGEUR, HAUTEUR);
 glutInitWindowPosition(100, 100);
 GLUTWINDOW=glutCreateWindow(NOM_Instance);

 init();

 glutDisplayFunc(display);
 glutIdleFunc(display);
 glutReshapeFunc(reshape);

 glutKeyboardFunc(keyboard);
 glutSpecialFunc(special);
 glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE,GLUT_ACTION_CONTINUE_EXECUTION);
 glutMainLoop();
 int i=1;
 glutInit(&i, ddd);

 //glutPostRedisplay();
//glutLeaveMainLoop();
solution_a_dessiner_c.clear();

 return 0;
}
//









#endif // DRAW_INCLUDED
